using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Herencia.Capas;
using Exferia_EntityFramework;
using Exferia_General._0_Modelos;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Transactions;
using static Exferia_Aplicacion.General.Enumerados;
using System.Runtime.CompilerServices;

namespace Exferia_General._1_Datos
{
    public class GEN_Control_Datos : ABS_Datos
    {

        #region Listado
        private List<INTERNO_GEN_Control_Listado_Modelo> g_lst_INTERNO_GEN_Control_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_GEN = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ........................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(GEN_Delegaciones).Name), _lst_CamposConRelacionABuscar, -1, null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                //.................................................................

                if ((g_lst_INTERNO_GEN_Control_Listado_Modelo != null) && (g_lst_INTERNO_GEN_Control_Listado_Modelo.Count() > 0))
                {
                    lst_GEN = g_lst_INTERNO_GEN_Control_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Control_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_GEN;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_GEN = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(GEN_Delegaciones).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                //...............................................................

                if ((g_lst_INTERNO_GEN_Control_Listado_Modelo != null) && (g_lst_INTERNO_GEN_Control_Listado_Modelo.Count() > 0))
                {
                    dnm_GEN = g_lst_INTERNO_GEN_Control_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Delegaciones_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_GEN;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicoActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {

                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idEmpresasRelacionadas);

                string str_SQL =
                       " SELECT " +
                           nameof(INTERNO_GEN_Control_Listado_Modelo.id) + " = " + nameof(GEN_Control) + "." + nameof(GEN_Control.id) + "," +
                           nameof(INTERNO_GEN_Control_Listado_Modelo.tipoContabilidad) + " = " + nameof(GEN_Control) + "." + nameof(GEN_Control.tipoContabilidad) + "," +
                           nameof(INTERNO_GEN_Control_Listado_Modelo.Control_Contabilidad_numeroDigitosContabilidad) + " = (CASE WHEN ( NOT " + nameof(GEN_ControlContabilidad) + "." + nameof(GEN_ControlContabilidad.numeroDigitosContabilidad) + " IS NULL) THEN " + nameof(GEN_ControlContabilidad) + "." + nameof(GEN_ControlContabilidad.numeroDigitosContabilidad) + " ELSE convert(bit,0) END),"+
                           nameof(INTERNO_GEN_Control_Listado_Modelo.ControlSGA_esObligatorioUbicacion) + " = (CASE WHEN ( NOT " + nameof(GEN_ControlSGA) + "." + nameof(GEN_ControlSGA.esObligatorioUbicacion) + " IS NULL ) THEN " + nameof(GEN_ControlSGA) + "." + nameof(GEN_ControlSGA.esObligatorioUbicacion) + " ELSE convert(bit, 0)  END)," +
                           //ids 
                           nameof(INTERNO_GEN_Control_Listado_Modelo.idPerfilFuncionalidad) + " = " + nameof(GEN_Control) + "." + nameof(GEN_Control.idPerfilFuncionalidad) + "," +
                           nameof(INTERNO_GEN_Control_Listado_Modelo.idVolcadoExportacion) + " = " + nameof(GEN_Control) + "." + nameof(GEN_Control.idVolcadoExportacion) + "," +
                           //PerfilFuncionalidad
                           (
                             (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_GEN_Control_Listado_Modelo.PerfilFuncionalidad)))
                               ?
                                   (
                                       nameof(INTERNO_GEN_Control_Listado_Modelo.PerfilFuncionalidad_Codigo) + " = " + nameof(GEN_PerfilesFuncionalidad) + "." + nameof(GEN_PerfilesFuncionalidad.codigo) + "," +
                                       nameof(INTERNO_GEN_Control_Listado_Modelo.PerfilFuncionalidad_Descripcion) + " =" + nameof(GEN_PerfilesFuncionalidad) + "." + nameof(GEN_PerfilesFuncionalidad.descripcion) + "," +
                                       nameof(INTERNO_GEN_Control_Listado_Modelo.PerfilFuncionalidad_FechaBorrado) + " =" + nameof(GEN_PerfilesFuncionalidad) + "." + nameof(GEN_PerfilesFuncionalidad.fechaBorrado) + ","
                                   )
                               :
                                   (
                                       nameof(INTERNO_GEN_Control_Listado_Modelo.PerfilFuncionalidad_Codigo) + " = ''," +
                                       nameof(INTERNO_GEN_Control_Listado_Modelo.PerfilFuncionalidad_Descripcion) + " = ''," +
                                       nameof(INTERNO_GEN_Control_Listado_Modelo.PerfilFuncionalidad_FechaBorrado) + " = NULL, "
                                   )
                           ) +
                           //VolcadoExportacion
                           (
                             (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_GEN_Control_Listado_Modelo.VolcadoExportacion)))
                               ?
                                   (
                                       nameof(INTERNO_GEN_Control_Listado_Modelo.VolcadoExportacion_Codigo) + " = " + nameof(GEN_VolcadoExportacion) + "." + nameof(GEN_VolcadoExportacion.codigo) + "," +
                                       nameof(INTERNO_GEN_Control_Listado_Modelo.VolcadoExportacion_Descripcion) + " =" + nameof(GEN_VolcadoExportacion) + "." + nameof(GEN_VolcadoExportacion.descripcion) + ","
                                   )
                               :
                                   (
                                       nameof(INTERNO_GEN_Control_Listado_Modelo.VolcadoExportacion_Codigo) + " = ''," +
                                       nameof(INTERNO_GEN_Control_Listado_Modelo.VolcadoExportacion_Descripcion) + " = ''"
                                   )
                           ) +
                    " FROM " + nameof(GEN_Control) +
                    //PerfilFuncionalidad
                    (
                         (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_GEN_Control_Listado_Modelo.PerfilFuncionalidad)))
                            ?
                                (
                                 " LEFT JOIN " + nameof(GEN_PerfilesFuncionalidad) + " ON " + nameof(GEN_Control) + "." + nameof(GEN_Control.idPerfilFuncionalidad) + " = " + nameof(GEN_PerfilesFuncionalidad) + "." + nameof(GEN_PerfilesFuncionalidad.id)
                                )
                            : ("")
                    ) +
                    //VolcadoExportacion
                    (
                         (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_GEN_Control_Listado_Modelo.PerfilFuncionalidad)))
                            ?
                                (
                                 " LEFT JOIN " + nameof(GEN_VolcadoExportacion) + " ON " + nameof(GEN_Control) + "." + nameof(GEN_Control.idVolcadoExportacion) + " = " + nameof(GEN_VolcadoExportacion) + "." + nameof(GEN_VolcadoExportacion.id)
                                )
                            : ("")
                    ) +
                    " INNER JOIN " + nameof(GEN_ControlContabilidad) + " ON " + nameof(GEN_Control) + "." + nameof(GEN_Control.idPerfilFuncionalidad) + " = " + nameof(GEN_ControlContabilidad) + "." + nameof(GEN_ControlContabilidad.idPerfilFuncionalidad) +
                    " INNER JOIN " + nameof(GEN_ControlSGA) + " ON " + nameof(GEN_ControlContabilidad) + "." + nameof(GEN_ControlContabilidad.idPerfilFuncionalidad) + " = " + nameof(GEN_ControlSGA) + "." + nameof(GEN_ControlSGA.idPerfilFuncionalidad) +
                    " WHERE " + (_lng_id > -1 ? nameof(GEN_Control) + "." + (nameof(GEN_Control.id) + "=@id") : "1 = 1");

                //Parametros
                object[] arr_Parametros = new object[]
                {
                    new SqlParameter("@id" , _lng_id)
                };

                //Rellenar el Modelo
                g_lst_INTERNO_GEN_Control_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_GEN_Control_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Control_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Obtener
        private dynamic g_dnm_Modelo_Obtener = null;

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                         " SELECT " +
                             nameof(GEN_Control) + "." + nameof(GEN_Control.id) + "," +
                             nameof(GEN_Control) + "." + nameof(GEN_Control.idPerfilFuncionalidad) + "," +
                             nameof(GEN_Control) + "." + nameof(GEN_Control.tipoContabilidad) + "," +
                             nameof(GEN_Control) + "." + nameof(GEN_Control.idVolcadoExportacion) +
                         " FROM " + nameof(GEN_Control) +
                         " WHERE  " + nameof(GEN_Control) + "." + nameof(GEN_Control.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<GEN_Control>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Control_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private GEN_Control g_mdl_GEN_Control = null;

        public GEN_Control Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE " + nameof(GEN_Control) + "." + nameof(GEN_Control.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Control_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_GEN_Control;
        }

        public GEN_Control Obtener_Modelo_Por_IdPerfilFuncionalidad(long _lng_idPerfilFuncionalidad)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " + nameof(GEN_Control) + "." + nameof(GEN_Control.idPerfilFuncionalidad) + "=@idPerfilFuncionalidad";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idPerfilFuncionalidad", _lng_idPerfilFuncionalidad)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL, arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Control_Datos) + "/" + nameof(Obtener_Modelo_Por_IdPerfilFuncionalidad), true);
            }

            return g_mdl_GEN_Control;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_GEN_Control = obj_Exferia_Entities.Database.SqlQuery<GEN_Control>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Control_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #endregion

        #region Modelo Listado
        private List<GEN_Control> g_lst_GEN_Control = null;

        public List<GEN_Control> Obtener_ModeloListado()
        {
            try
            {

                string str_SQL = Obtener_Consulta_Modelo();

                //Parametros
                object[] arr_Parametros = new object[1];

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Control_Datos) + "/" + nameof(Obtener_ModeloListado), true);
            }

            return g_lst_GEN_Control;
        }

        #region Ejecutar Consulta
        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                      object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_GEN_Control = obj_Exferia_Entities.Database.SqlQuery<GEN_Control>(_str_SQL, _arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Control_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(GEN_Control.id) + " , " +
                    nameof(GEN_Control.idPerfilFuncionalidad) + " , " +
                    nameof(GEN_Control.tipoContabilidad) + " , " +
                    nameof(GEN_Control.idVolcadoExportacion) +
                " FROM " + nameof(GEN_Control);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                GEN_Control mdl_GEN_Control_AGrabar = (GEN_Control)_mdl_obj;
                GEN_Control mdl_GEN_Control_DatosViejos = new GEN_Control();

                // Ver si existe ######################################################################
                GEN_Control mdl_GEN_Control_Final = Obtener_Modelo_Por_Id(mdl_GEN_Control_AGrabar.id);
                //#####################################################################################

                //UPDATE
                if (mdl_GEN_Control_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_GEN_Control_Final, mdl_GEN_Control_DatosViejos, false, false);

                    //Cargar los datos nuevos del modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_GEN_Control_AGrabar, mdl_GEN_Control_Final, false, false);


                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(GEN_Control) +
                                            " SET " +
                                                 nameof(GEN_Control.idPerfilFuncionalidad) + "=@idPerfilFuncionalidad," +
                                                 nameof(GEN_Control.tipoContabilidad) + "=@tipoContabilidad," +
                                                 nameof(GEN_Control.idVolcadoExportacion) + "=@idVolcadoExportacion" +
                                            " WHERE " +
                                                nameof(GEN_Control.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@idPerfilFuncionalidad",  mdl_GEN_Control_Final.idPerfilFuncionalidad),
                        mdl_GEN_Control_Final.tipoContabilidad != null
                            ?   new SqlParameter("@tipoContabilidad", mdl_GEN_Control_Final.tipoContabilidad)
                            :   new SqlParameter("@tipoContabilidad",  DBNull.Value),
                        mdl_GEN_Control_Final.idVolcadoExportacion != null
                            ?   new SqlParameter("@idVolcadoExportacion", mdl_GEN_Control_Final.idVolcadoExportacion.Value)
                            :   new SqlParameter("@idVolcadoExportacion",  DBNull.Value),
                        new SqlParameter("@id", mdl_GEN_Control_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_GEN_Control_Final.id;
                }
                //INSERT
                else
                {
                    mdl_GEN_Control_Final = new GEN_Control();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_GEN_Control_AGrabar, mdl_GEN_Control_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(GEN_Control) +
                                                " (" +
                                                        nameof(GEN_Control.idPerfilFuncionalidad) + "," +
                                                        nameof(GEN_Control.tipoContabilidad) + "," +
                                                        nameof(GEN_Control.idVolcadoExportacion) +
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(GEN_Control.id) +
                                                " VALUES " +
                                                " ( " +
                                                   "@idPerfilFuncionalidad," +
                                                   "@tipoContabilidad," +
                                                   "@idVolcadoExportacion" +
                                                " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idPerfilFuncionalidad",  mdl_GEN_Control_Final.idPerfilFuncionalidad),
                        mdl_GEN_Control_Final.tipoContabilidad != null
                            ?   new SqlParameter("@tipoContabilidad", mdl_GEN_Control_Final.tipoContabilidad)
                            :   new SqlParameter("@tipoContabilidad",  DBNull.Value),
                        mdl_GEN_Control_Final.idVolcadoExportacion != null
                            ?   new SqlParameter("@idVolcadoExportacion", mdl_GEN_Control_Final.idVolcadoExportacion.Value)
                            :   new SqlParameter("@idVolcadoExportacion",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                //Grabar un registro de trazabilidad con los datos de la transaccion realizada
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(GEN_Control), mdl_GEN_Control_DatosViejos, mdl_GEN_Control_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Control_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar (long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                GEN_Control mdl_GEN_Control_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_GEN_Control_Final != null)
                {
                    #region Delete
                    string str_SQL_Delete = " DELETE FROM  " + nameof(GEN_Control) +
                                            " WHERE " +
                                                nameof(GEN_Control.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Delete = new object[]
                    {
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Delete
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

                    //Grabar un registro de trazabailidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(GEN_Control), null, mdl_GEN_Control_Final, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                // Devolver también el Objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(GEN_Control_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            throw new NotImplementedException();
        }
        #endregion
    }
}